<script lang="ts">
import Vue from 'vue';
import { AosAnimationsMixin, LocalizedHrefMixin } from '../mixins';
import { NAV_CONTENT_TYPES } from '../common/content-types';
import SlpNavigationHOC from '../components/navigation/navigation-hoc.vue';
import CodeSuggestionsSalesHOC from '~/components/navigation/code-suggestions-sale.vue';
import { convertToCaseSensitiveLocale } from '../common/util';

import { getNavigationClient } from '~/plugins/contentful';
import { generateLayoutMeta } from '~/common/meta';

export default Vue.extend({
  components: {
    SlpNavigationHOC,
    CodeSuggestionsSalesHOC,
  },
  mixins: [LocalizedHrefMixin, AosAnimationsMixin],
  data() {
    return {
      footer: {},
      submitted: false,
    };
  },
  async fetch() {
    const footerEntry = await getNavigationClient().getEntries({
      content_type: NAV_CONTENT_TYPES.FOOTER,
      'sys.id': 'QxdoqHd5ixKTwFjIHYvYI',
      include: 3,
      locale: convertToCaseSensitiveLocale(this.$i18n.locale),
    });

    const [footer] = footerEntry.items;

    this.footer = footer;
  },
  head() {
    return generateLayoutMeta(this.$route.path, this.$i18n.locale);
  },
  beforeMount() {
    this.validateIndexFiles();
  },
  created() {
    this.$nuxt.$on('submit', () => {
      this.submitted = !this.submitted;
    });
  },
  methods: {
    validateIndexFiles() {
      if (this.$route.path.endsWith('index.html')) {
        const queryParams = this.$route.query;
        const oldPath = this.$route.path.replace(/(\W*index\.html\W*)/g, '');
        this.$router.replace({
          path: `${oldPath}/`,
          query: queryParams,
        });
      }
    },
  },
});
</script>

<template>
  <div>
    <SlpNavigationHOC v-show="submitted" key="slp-nav" />
    <CodeSuggestionsSalesHOC
      v-show="!submitted"
      key="min-nav"
      entry-id="4zY5Z8zzo4lsnyeTQB8h1d"
    />

    <section ref="localizedContainer">
      <Nuxt role="main" />
    </section>
    <client-only>
      <SlpMinimizedFooter :contentful-footer-data="footer" />
    </client-only>
  </div>
</template>

<style>
.list-enter-active,
.list-leave-active {
  transition: all 0.5s ease;
}
.list-enter-from,
.list-leave-to {
  opacity: 0;
  height: 0;
  transform: translateX(30px);
}
</style>
